// Code generated by goagen v1.3.1, DO NOT EDIT.
//
// API "Modoki API": CLI Commands
//
// Command:
// $ goagen
// --design=github.com/modoki-paas/modoki/design
// --out=$(GOPATH)/src/github.com/modoki-paas/modoki
// --version=v1.3.1

package cli

import (
	"context"
	"encoding/json"
	"fmt"
	"github.com/goadesign/goa"
	goaclient "github.com/goadesign/goa/client"
	uuid "github.com/goadesign/goa/uuid"
	"github.com/modoki-paas/modoki/client"
	"github.com/spf13/cobra"
	"log"
	"net/url"
	"os"
	"strconv"
	"strings"
	"time"
)

type (
	// CreateContainerCommand is the command line data structure for the create action of container
	CreateContainerCommand struct {
		// Command to run specified as a string or an array of strings.
		Command []string
		// The entry point for the container as a string or an array of strings
		Entrypoint []string
		// Environment variables
		Env []string
		// Name of image
		Image string
		// Name of container and subdomain
		Name string
		// Whether HTTP is redirected to HTTPS
		SslRedirect string
		// Path to volumes in a container
		Volumes []string
		// Current directory (PWD) in the command will be launched
		WorkingDir  string
		PrettyPrint bool
	}

	// DownloadContainerCommand is the command line data structure for the download action of container
	DownloadContainerCommand struct {
		// ID or name
		ID string
		// Path in the container to save files
		InternalPath string
		PrettyPrint  bool
	}

	// ExecContainerCommand is the command line data structure for the exec action of container
	ExecContainerCommand struct {
		// id or name
		ID string
		// The path to the executable file
		Command []string
		// Tty
		Tty         string
		PrettyPrint bool
	}

	// GetConfigContainerCommand is the command line data structure for the getConfig action of container
	GetConfigContainerCommand struct {
		// id or name
		ID          string
		PrettyPrint bool
	}

	// InspectContainerCommand is the command line data structure for the inspect action of container
	InspectContainerCommand struct {
		// ID or name
		ID          string
		PrettyPrint bool
	}

	// ListContainerCommand is the command line data structure for the list action of container
	ListContainerCommand struct {
		PrettyPrint bool
	}

	// LogsContainerCommand is the command line data structure for the logs action of container
	LogsContainerCommand struct {
		// id or name
		ID          string
		Follow      string
		Since       string
		Stderr      string
		Stdout      string
		Tail        string
		Timestamps  string
		Until       string
		PrettyPrint bool
	}

	// RemoveContainerCommand is the command line data structure for the remove action of container
	RemoveContainerCommand struct {
		// id or name
		ID string
		// If the container is running, kill it before removing it.
		Force       string
		PrettyPrint bool
	}

	// SetConfigContainerCommand is the command line data structure for the setConfig action of container
	SetConfigContainerCommand struct {
		Payload     string
		ContentType string
		// id or name
		ID          string
		PrettyPrint bool
	}

	// StartContainerCommand is the command line data structure for the start action of container
	StartContainerCommand struct {
		// id or name
		ID          string
		PrettyPrint bool
	}

	// StopContainerCommand is the command line data structure for the stop action of container
	StopContainerCommand struct {
		// id or name
		ID          string
		PrettyPrint bool
	}

	// UploadContainerCommand is the command line data structure for the upload action of container
	UploadContainerCommand struct {
		Payload     string
		ContentType string
		// ID or name
		ID          string
		PrettyPrint bool
	}

	// AddAuthorizedKeysUserCommand is the command line data structure for the addAuthorizedKeys action of user
	AddAuthorizedKeysUserCommand struct {
		Payload     string
		ContentType string
		PrettyPrint bool
	}

	// GetConfigUserCommand is the command line data structure for the getConfig action of user
	GetConfigUserCommand struct {
		PrettyPrint bool
	}

	// GetDefaultShellUserCommand is the command line data structure for the getDefaultShell action of user
	GetDefaultShellUserCommand struct {
		PrettyPrint bool
	}

	// ListAuthorizedKeysUserCommand is the command line data structure for the listAuthorizedKeys action of user
	ListAuthorizedKeysUserCommand struct {
		PrettyPrint bool
	}

	// RemoveAuthorizedKeysUserCommand is the command line data structure for the removeAuthorizedKeys action of user
	RemoveAuthorizedKeysUserCommand struct {
		Label       string
		PrettyPrint bool
	}

	// SetAuthorizedKeysUserCommand is the command line data structure for the setAuthorizedKeys action of user
	SetAuthorizedKeysUserCommand struct {
		Payload     string
		ContentType string
		PrettyPrint bool
	}

	// SetDefaultShellUserCommand is the command line data structure for the setDefaultShell action of user
	SetDefaultShellUserCommand struct {
		DefaultShell string
		PrettyPrint  bool
	}

	// DownloadCommand is the command line data structure for the download command.
	DownloadCommand struct {
		// OutFile is the path to the download output file.
		OutFile string
	}
)

// RegisterCommands registers the resource action CLI commands.
func RegisterCommands(app *cobra.Command, c *client.Client) {
	var command, sub *cobra.Command
	command = &cobra.Command{
		Use:   "add-authorized-keys",
		Short: ``,
	}
	tmp1 := new(AddAuthorizedKeysUserCommand)
	sub = &cobra.Command{
		Use:   `user ["/api/v2/user/config/authorizedKeys"]`,
		Short: ``,
		Long: `

Payload example:

{
   "key": "nufwk5tf2z",
   "label": "74"
}`,
		RunE: func(cmd *cobra.Command, args []string) error { return tmp1.Run(c, args) },
	}
	tmp1.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp1.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "create",
		Short: `create a new container`,
	}
	tmp2 := new(CreateContainerCommand)
	sub = &cobra.Command{
		Use:   `container ["/api/v2/container/create"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp2.Run(c, args) },
	}
	tmp2.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp2.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "download",
		Short: `Copy files from the container`,
	}
	tmp3 := new(DownloadContainerCommand)
	sub = &cobra.Command{
		Use:   `container [("/api/v2/container/ID/download"|"/api/v2/container/download")]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp3.Run(c, args) },
	}
	tmp3.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp3.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "exec",
		Short: `Exec a command with attaching to a container using WebSocket(Mainly for xterm.js, using a protocol for terminado)`,
	}
	tmp4 := new(ExecContainerCommand)
	sub = &cobra.Command{
		Use:   `container ["/api/v2/container/ID/exec"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp4.Run(c, args) },
	}
	tmp4.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp4.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "get-config",
		Short: `getConfig action`,
	}
	tmp5 := new(GetConfigContainerCommand)
	sub = &cobra.Command{
		Use:   `container ["/api/v2/container/ID/config"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp5.Run(c, args) },
	}
	tmp5.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp5.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	tmp6 := new(GetConfigUserCommand)
	sub = &cobra.Command{
		Use:   `user ["/api/v2/user/config"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp6.Run(c, args) },
	}
	tmp6.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp6.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "get-default-shell",
		Short: ``,
	}
	tmp7 := new(GetDefaultShellUserCommand)
	sub = &cobra.Command{
		Use:   `user ["/api/v2/user/config/defaultShell"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp7.Run(c, args) },
	}
	tmp7.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp7.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "inspect",
		Short: `Return details of a container`,
	}
	tmp8 := new(InspectContainerCommand)
	sub = &cobra.Command{
		Use:   `container ["/api/v2/container/ID/inspect"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp8.Run(c, args) },
	}
	tmp8.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp8.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "list",
		Short: `Return a list of containers`,
	}
	tmp9 := new(ListContainerCommand)
	sub = &cobra.Command{
		Use:   `container ["/api/v2/container/list"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp9.Run(c, args) },
	}
	tmp9.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp9.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "list-authorized-keys",
		Short: ``,
	}
	tmp10 := new(ListAuthorizedKeysUserCommand)
	sub = &cobra.Command{
		Use:   `user ["/api/v2/user/config/authorizedKeys"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp10.Run(c, args) },
	}
	tmp10.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp10.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "logs",
		Short: `Get stdout and stderr logs from a container.`,
	}
	tmp11 := new(LogsContainerCommand)
	sub = &cobra.Command{
		Use:   `container ["/api/v2/container/ID/logs"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp11.Run(c, args) },
	}
	tmp11.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp11.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "remove",
		Short: `remove a container`,
	}
	tmp12 := new(RemoveContainerCommand)
	sub = &cobra.Command{
		Use:   `container ["/api/v2/container/ID/remove"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp12.Run(c, args) },
	}
	tmp12.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp12.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "remove-authorized-keys",
		Short: ``,
	}
	tmp13 := new(RemoveAuthorizedKeysUserCommand)
	sub = &cobra.Command{
		Use:   `user ["/api/v2/user/config/authorizedKeys"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp13.Run(c, args) },
	}
	tmp13.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp13.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "set-authorized-keys",
		Short: ``,
	}
	tmp14 := new(SetAuthorizedKeysUserCommand)
	sub = &cobra.Command{
		Use:   `user ["/api/v2/user/config/authorizedKeys"]`,
		Short: ``,
		Long: `

Payload example:

[
   {
      "key": "nufwk5tf2z",
      "label": "74"
   },
   {
      "key": "nufwk5tf2z",
      "label": "74"
   }
]`,
		RunE: func(cmd *cobra.Command, args []string) error { return tmp14.Run(c, args) },
	}
	tmp14.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp14.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "set-config",
		Short: `Change the config of a container`,
	}
	tmp15 := new(SetConfigContainerCommand)
	sub = &cobra.Command{
		Use:   `container ["/api/v2/container/ID/config"]`,
		Short: ``,
		Long: `

Payload example:

{
   "defaultShell": "Aut nobis saepe."
}`,
		RunE: func(cmd *cobra.Command, args []string) error { return tmp15.Run(c, args) },
	}
	tmp15.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp15.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "set-default-shell",
		Short: ``,
	}
	tmp16 := new(SetDefaultShellUserCommand)
	sub = &cobra.Command{
		Use:   `user ["/api/v2/user/config/defaultShell"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp16.Run(c, args) },
	}
	tmp16.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp16.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "start",
		Short: `start a container`,
	}
	tmp17 := new(StartContainerCommand)
	sub = &cobra.Command{
		Use:   `container ["/api/v2/container/ID/start"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp17.Run(c, args) },
	}
	tmp17.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp17.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "stop",
		Short: `stop a container`,
	}
	tmp18 := new(StopContainerCommand)
	sub = &cobra.Command{
		Use:   `container ["/api/v2/container/ID/stop"]`,
		Short: ``,
		RunE:  func(cmd *cobra.Command, args []string) error { return tmp18.Run(c, args) },
	}
	tmp18.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp18.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)
	command = &cobra.Command{
		Use:   "upload",
		Short: `Copy files to the container`,
	}
	tmp19 := new(UploadContainerCommand)
	sub = &cobra.Command{
		Use:   `container ["/api/v2/container/ID/upload"]`,
		Short: ``,
		Long: `

Payload example:

{
   "allowOverwrite": false,
   "copyUIDGID": true,
   "data": "Quas omnis tenetur ut.jpg",
   "path": "Fugit aut officia."
}`,
		RunE: func(cmd *cobra.Command, args []string) error { return tmp19.Run(c, args) },
	}
	tmp19.RegisterFlags(sub, c)
	sub.PersistentFlags().BoolVar(&tmp19.PrettyPrint, "pp", false, "Pretty print response body")
	command.AddCommand(sub)
	app.AddCommand(command)

	dl := new(DownloadCommand)
	dlc := &cobra.Command{
		Use:   "download [PATH]",
		Short: "Download file with given path",
		RunE: func(cmd *cobra.Command, args []string) error {
			return dl.Run(c, args)
		},
	}
	dlc.Flags().StringVar(&dl.OutFile, "out", "", "Output file")
	app.AddCommand(dlc)
}

func intFlagVal(name string, parsed int) *int {
	if hasFlag(name) {
		return &parsed
	}
	return nil
}

func float64FlagVal(name string, parsed float64) *float64 {
	if hasFlag(name) {
		return &parsed
	}
	return nil
}

func boolFlagVal(name string, parsed bool) *bool {
	if hasFlag(name) {
		return &parsed
	}
	return nil
}

func stringFlagVal(name string, parsed string) *string {
	if hasFlag(name) {
		return &parsed
	}
	return nil
}

func hasFlag(name string) bool {
	for _, arg := range os.Args[1:] {
		if strings.HasPrefix(arg, "--"+name) {
			return true
		}
	}
	return false
}

func jsonVal(val string) (*interface{}, error) {
	var t interface{}
	err := json.Unmarshal([]byte(val), &t)
	if err != nil {
		return nil, err
	}
	return &t, nil
}

func jsonArray(ins []string) ([]interface{}, error) {
	if ins == nil {
		return nil, nil
	}
	var vals []interface{}
	for _, id := range ins {
		val, err := jsonVal(id)
		if err != nil {
			return nil, err
		}
		vals = append(vals, val)
	}
	return vals, nil
}

func timeVal(val string) (*time.Time, error) {
	t, err := time.Parse(time.RFC3339, val)
	if err != nil {
		return nil, err
	}
	return &t, nil
}

func timeArray(ins []string) ([]time.Time, error) {
	if ins == nil {
		return nil, nil
	}
	var vals []time.Time
	for _, id := range ins {
		val, err := timeVal(id)
		if err != nil {
			return nil, err
		}
		vals = append(vals, *val)
	}
	return vals, nil
}

func uuidVal(val string) (*uuid.UUID, error) {
	t, err := uuid.FromString(val)
	if err != nil {
		return nil, err
	}
	return &t, nil
}

func uuidArray(ins []string) ([]uuid.UUID, error) {
	if ins == nil {
		return nil, nil
	}
	var vals []uuid.UUID
	for _, id := range ins {
		val, err := uuidVal(id)
		if err != nil {
			return nil, err
		}
		vals = append(vals, *val)
	}
	return vals, nil
}

func float64Val(val string) (*float64, error) {
	t, err := strconv.ParseFloat(val, 64)
	if err != nil {
		return nil, err
	}
	return &t, nil
}

func float64Array(ins []string) ([]float64, error) {
	if ins == nil {
		return nil, nil
	}
	var vals []float64
	for _, id := range ins {
		val, err := float64Val(id)
		if err != nil {
			return nil, err
		}
		vals = append(vals, *val)
	}
	return vals, nil
}

func boolVal(val string) (*bool, error) {
	t, err := strconv.ParseBool(val)
	if err != nil {
		return nil, err
	}
	return &t, nil
}

func boolArray(ins []string) ([]bool, error) {
	if ins == nil {
		return nil, nil
	}
	var vals []bool
	for _, id := range ins {
		val, err := boolVal(id)
		if err != nil {
			return nil, err
		}
		vals = append(vals, *val)
	}
	return vals, nil
}

// Run downloads files with given paths.
func (cmd *DownloadCommand) Run(c *client.Client, args []string) error {
	var (
		fnf func(context.Context, string) (int64, error)
		fnd func(context.Context, string, string) (int64, error)

		rpath   = args[0]
		outfile = cmd.OutFile
		logger  = goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
		ctx     = goa.WithLogger(context.Background(), logger)
		err     error
	)

	if rpath[0] != '/' {
		rpath = "/" + rpath
	}
	if rpath == "/api/v2/swagger/swagger.json" {
		fnf = c.DownloadSwaggerJSON
		if outfile == "" {
			outfile = "swagger.json"
		}
		goto found
	}
	if rpath == "/api/v2/swagger/swagger.yaml" {
		fnf = c.DownloadSwaggerYaml
		if outfile == "" {
			outfile = "swagger.yaml"
		}
		goto found
	}
	return fmt.Errorf("don't know how to download %s", rpath)
found:
	ctx = goa.WithLogContext(ctx, "file", outfile)
	if fnf != nil {
		_, err = fnf(ctx, outfile)
	} else {
		_, err = fnd(ctx, rpath, outfile)
	}
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	return nil
}

// Run makes the HTTP request corresponding to the CreateContainerCommand command.
func (cmd *CreateContainerCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = "/api/v2/container/create"
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	var tmp20 *bool
	if cmd.SslRedirect != "" {
		var err error
		tmp20, err = boolVal(cmd.SslRedirect)
		if err != nil {
			goa.LogError(ctx, "failed to parse flag into *bool value", "flag", "--sslRedirect", "err", err)
			return err
		}
	}
	resp, err := c.CreateContainer(ctx, path, cmd.Image, cmd.Name, cmd.Command, cmd.Entrypoint, cmd.Env, tmp20, cmd.Volumes, stringFlagVal("workingDir", cmd.WorkingDir))
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *CreateContainerCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	var command []string
	cc.Flags().StringSliceVar(&cmd.Command, "command", command, `Command to run specified as a string or an array of strings.`)
	var entrypoint []string
	cc.Flags().StringSliceVar(&cmd.Entrypoint, "entrypoint", entrypoint, `The entry point for the container as a string or an array of strings`)
	var env []string
	cc.Flags().StringSliceVar(&cmd.Env, "env", env, `Environment variables`)
	var image string
	cc.Flags().StringVar(&cmd.Image, "image", image, `Name of image`)
	var name string
	cc.Flags().StringVar(&cmd.Name, "name", name, `Name of container and subdomain`)
	cc.Flags().StringVar(&cmd.SslRedirect, "sslRedirect", "true", `Whether HTTP is redirected to HTTPS`)
	var volumes []string
	cc.Flags().StringSliceVar(&cmd.Volumes, "volumes", volumes, `Path to volumes in a container`)
	var workingDir string
	cc.Flags().StringVar(&cmd.WorkingDir, "workingDir", workingDir, `Current directory (PWD) in the command will be launched`)
}

// Run makes the HTTP request corresponding to the DownloadContainerCommand command.
func (cmd *DownloadContainerCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = "/api/v2/container/download"
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.DownloadContainer(ctx, path, cmd.InternalPath)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *DownloadContainerCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	var id string
	cc.Flags().StringVar(&cmd.ID, "id", id, `ID or name`)
	var internalPath string
	cc.Flags().StringVar(&cmd.InternalPath, "internalPath", internalPath, `Path in the container to save files`)
}

// Run establishes a websocket connection for the ExecContainerCommand command.
func (cmd *ExecContainerCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = fmt.Sprintf("/api/v2/container/%v/exec", url.QueryEscape(cmd.ID))
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	var tmp21 *bool
	if cmd.Tty != "" {
		var err error
		tmp21, err = boolVal(cmd.Tty)
		if err != nil {
			goa.LogError(ctx, "failed to parse flag into *bool value", "flag", "--tty", "err", err)
			return err
		}
	}
	ws, err := c.ExecContainer(ctx, path, cmd.Command, tmp21)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}
	go goaclient.WSWrite(ws)
	goaclient.WSRead(ws)

	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *ExecContainerCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	var id string
	cc.Flags().StringVar(&cmd.ID, "id", id, `id or name`)
	var command []string
	cc.Flags().StringSliceVar(&cmd.Command, "command", command, `The path to the executable file`)
	var tty string
	cc.Flags().StringVar(&cmd.Tty, "tty", tty, `Tty`)
}

// Run makes the HTTP request corresponding to the GetConfigContainerCommand command.
func (cmd *GetConfigContainerCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = fmt.Sprintf("/api/v2/container/%v/config", url.QueryEscape(cmd.ID))
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.GetConfigContainer(ctx, path)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *GetConfigContainerCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	var id string
	cc.Flags().StringVar(&cmd.ID, "id", id, `id or name`)
}

// Run makes the HTTP request corresponding to the InspectContainerCommand command.
func (cmd *InspectContainerCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = fmt.Sprintf("/api/v2/container/%v/inspect", url.QueryEscape(cmd.ID))
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.InspectContainer(ctx, path)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *InspectContainerCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	var id string
	cc.Flags().StringVar(&cmd.ID, "id", id, `ID or name`)
}

// Run makes the HTTP request corresponding to the ListContainerCommand command.
func (cmd *ListContainerCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = "/api/v2/container/list"
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.ListContainer(ctx, path)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *ListContainerCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
}

// Run establishes a websocket connection for the LogsContainerCommand command.
func (cmd *LogsContainerCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = fmt.Sprintf("/api/v2/container/%v/logs", url.QueryEscape(cmd.ID))
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	var tmp22 *bool
	if cmd.Follow != "" {
		var err error
		tmp22, err = boolVal(cmd.Follow)
		if err != nil {
			goa.LogError(ctx, "failed to parse flag into *bool value", "flag", "--follow", "err", err)
			return err
		}
	}
	var tmp23 *time.Time
	if cmd.Since != "" {
		var err error
		tmp23, err = timeVal(cmd.Since)
		if err != nil {
			goa.LogError(ctx, "failed to parse flag into *time.Time value", "flag", "--since", "err", err)
			return err
		}
	}
	var tmp24 *bool
	if cmd.Stderr != "" {
		var err error
		tmp24, err = boolVal(cmd.Stderr)
		if err != nil {
			goa.LogError(ctx, "failed to parse flag into *bool value", "flag", "--stderr", "err", err)
			return err
		}
	}
	var tmp25 *bool
	if cmd.Stdout != "" {
		var err error
		tmp25, err = boolVal(cmd.Stdout)
		if err != nil {
			goa.LogError(ctx, "failed to parse flag into *bool value", "flag", "--stdout", "err", err)
			return err
		}
	}
	var tmp26 *bool
	if cmd.Timestamps != "" {
		var err error
		tmp26, err = boolVal(cmd.Timestamps)
		if err != nil {
			goa.LogError(ctx, "failed to parse flag into *bool value", "flag", "--timestamps", "err", err)
			return err
		}
	}
	var tmp27 *time.Time
	if cmd.Until != "" {
		var err error
		tmp27, err = timeVal(cmd.Until)
		if err != nil {
			goa.LogError(ctx, "failed to parse flag into *time.Time value", "flag", "--until", "err", err)
			return err
		}
	}
	ws, err := c.LogsContainer(ctx, path, tmp22, tmp23, tmp24, tmp25, stringFlagVal("tail", cmd.Tail), tmp26, tmp27)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}
	go goaclient.WSWrite(ws)
	goaclient.WSRead(ws)

	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *LogsContainerCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	var id string
	cc.Flags().StringVar(&cmd.ID, "id", id, `id or name`)
	var follow string
	cc.Flags().StringVar(&cmd.Follow, "follow", follow, ``)
	var since string
	cc.Flags().StringVar(&cmd.Since, "since", since, ``)
	var stderr string
	cc.Flags().StringVar(&cmd.Stderr, "stderr", stderr, ``)
	var stdout string
	cc.Flags().StringVar(&cmd.Stdout, "stdout", stdout, ``)
	cc.Flags().StringVar(&cmd.Tail, "tail", "all", ``)
	var timestamps string
	cc.Flags().StringVar(&cmd.Timestamps, "timestamps", timestamps, ``)
	var until string
	cc.Flags().StringVar(&cmd.Until, "until", until, ``)
}

// Run makes the HTTP request corresponding to the RemoveContainerCommand command.
func (cmd *RemoveContainerCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = fmt.Sprintf("/api/v2/container/%v/remove", url.QueryEscape(cmd.ID))
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	var tmp28 *bool
	if cmd.Force != "" {
		var err error
		tmp28, err = boolVal(cmd.Force)
		if err != nil {
			goa.LogError(ctx, "failed to parse flag into *bool value", "flag", "--force", "err", err)
			return err
		}
	}
	if tmp28 == nil {
		goa.LogError(ctx, "required flag is missing", "flag", "--force")
		return fmt.Errorf("required flag force is missing")
	}
	resp, err := c.RemoveContainer(ctx, path, *tmp28)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *RemoveContainerCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	var id string
	cc.Flags().StringVar(&cmd.ID, "id", id, `id or name`)
	var force string
	cc.Flags().StringVar(&cmd.Force, "force", force, `If the container is running, kill it before removing it.`)
}

// Run makes the HTTP request corresponding to the SetConfigContainerCommand command.
func (cmd *SetConfigContainerCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = fmt.Sprintf("/api/v2/container/%v/config", url.QueryEscape(cmd.ID))
	}
	var payload client.ContainerConfig
	if cmd.Payload != "" {
		err := json.Unmarshal([]byte(cmd.Payload), &payload)
		if err != nil {
			return fmt.Errorf("failed to deserialize payload: %s", err)
		}
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.SetConfigContainer(ctx, path, &payload, cmd.ContentType)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *SetConfigContainerCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	cc.Flags().StringVar(&cmd.Payload, "payload", "", "Request body encoded in JSON")
	cc.Flags().StringVar(&cmd.ContentType, "content", "", "Request content type override, e.g. 'application/x-www-form-urlencoded'")
	var id string
	cc.Flags().StringVar(&cmd.ID, "id", id, `id or name`)
}

// Run makes the HTTP request corresponding to the StartContainerCommand command.
func (cmd *StartContainerCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = fmt.Sprintf("/api/v2/container/%v/start", url.QueryEscape(cmd.ID))
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.StartContainer(ctx, path)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *StartContainerCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	var id string
	cc.Flags().StringVar(&cmd.ID, "id", id, `id or name`)
}

// Run makes the HTTP request corresponding to the StopContainerCommand command.
func (cmd *StopContainerCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = fmt.Sprintf("/api/v2/container/%v/stop", url.QueryEscape(cmd.ID))
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.StopContainer(ctx, path)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *StopContainerCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	var id string
	cc.Flags().StringVar(&cmd.ID, "id", id, `id or name`)
}

// Run makes the HTTP request corresponding to the UploadContainerCommand command.
func (cmd *UploadContainerCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = fmt.Sprintf("/api/v2/container/%v/upload", url.QueryEscape(cmd.ID))
	}
	var payload client.UploadPayload
	if cmd.Payload != "" {
		err := json.Unmarshal([]byte(cmd.Payload), &payload)
		if err != nil {
			return fmt.Errorf("failed to deserialize payload: %s", err)
		}
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.UploadContainer(ctx, path, &payload, cmd.ContentType)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *UploadContainerCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	cc.Flags().StringVar(&cmd.Payload, "payload", "", "Request body encoded in JSON")
	cc.Flags().StringVar(&cmd.ContentType, "content", "", "Request content type override, e.g. 'application/x-www-form-urlencoded'")
	var id string
	cc.Flags().StringVar(&cmd.ID, "id", id, `ID or name`)
}

// Run makes the HTTP request corresponding to the AddAuthorizedKeysUserCommand command.
func (cmd *AddAuthorizedKeysUserCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = "/api/v2/user/config/authorizedKeys"
	}
	var payload client.UserAuthorizedKey
	if cmd.Payload != "" {
		err := json.Unmarshal([]byte(cmd.Payload), &payload)
		if err != nil {
			return fmt.Errorf("failed to deserialize payload: %s", err)
		}
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.AddAuthorizedKeysUser(ctx, path, &payload, cmd.ContentType)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *AddAuthorizedKeysUserCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	cc.Flags().StringVar(&cmd.Payload, "payload", "", "Request body encoded in JSON")
	cc.Flags().StringVar(&cmd.ContentType, "content", "", "Request content type override, e.g. 'application/x-www-form-urlencoded'")
}

// Run makes the HTTP request corresponding to the GetConfigUserCommand command.
func (cmd *GetConfigUserCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = "/api/v2/user/config"
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.GetConfigUser(ctx, path)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *GetConfigUserCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
}

// Run makes the HTTP request corresponding to the GetDefaultShellUserCommand command.
func (cmd *GetDefaultShellUserCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = "/api/v2/user/config/defaultShell"
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.GetDefaultShellUser(ctx, path)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *GetDefaultShellUserCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
}

// Run makes the HTTP request corresponding to the ListAuthorizedKeysUserCommand command.
func (cmd *ListAuthorizedKeysUserCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = "/api/v2/user/config/authorizedKeys"
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.ListAuthorizedKeysUser(ctx, path)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *ListAuthorizedKeysUserCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
}

// Run makes the HTTP request corresponding to the RemoveAuthorizedKeysUserCommand command.
func (cmd *RemoveAuthorizedKeysUserCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = "/api/v2/user/config/authorizedKeys"
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.RemoveAuthorizedKeysUser(ctx, path, cmd.Label)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *RemoveAuthorizedKeysUserCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	var label string
	cc.Flags().StringVar(&cmd.Label, "label", label, ``)
}

// Run makes the HTTP request corresponding to the SetAuthorizedKeysUserCommand command.
func (cmd *SetAuthorizedKeysUserCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = "/api/v2/user/config/authorizedKeys"
	}
	var payload client.SetAuthorizedKeysUserPayload
	if cmd.Payload != "" {
		err := json.Unmarshal([]byte(cmd.Payload), &payload)
		if err != nil {
			return fmt.Errorf("failed to deserialize payload: %s", err)
		}
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.SetAuthorizedKeysUser(ctx, path, payload, cmd.ContentType)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *SetAuthorizedKeysUserCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	cc.Flags().StringVar(&cmd.Payload, "payload", "", "Request body encoded in JSON")
	cc.Flags().StringVar(&cmd.ContentType, "content", "", "Request content type override, e.g. 'application/x-www-form-urlencoded'")
}

// Run makes the HTTP request corresponding to the SetDefaultShellUserCommand command.
func (cmd *SetDefaultShellUserCommand) Run(c *client.Client, args []string) error {
	var path string
	if len(args) > 0 {
		path = args[0]
	} else {
		path = "/api/v2/user/config/defaultShell"
	}
	logger := goa.NewLogger(log.New(os.Stderr, "", log.LstdFlags))
	ctx := goa.WithLogger(context.Background(), logger)
	resp, err := c.SetDefaultShellUser(ctx, path, cmd.DefaultShell)
	if err != nil {
		goa.LogError(ctx, "failed", "err", err)
		return err
	}

	goaclient.HandleResponse(c.Client, resp, cmd.PrettyPrint)
	return nil
}

// RegisterFlags registers the command flags with the command line.
func (cmd *SetDefaultShellUserCommand) RegisterFlags(cc *cobra.Command, c *client.Client) {
	var defaultShell string
	cc.Flags().StringVar(&cmd.DefaultShell, "defaultShell", defaultShell, ``)
}
